// AnonymousInnerClassDemo2.java

abstract class Farmer
{
   protected String name;

   Farmer (String name)
   {
      this.name = name;
   }

   abstract void occupation ();
}

class BeefFarmer extends Farmer
{
   BeefFarmer (String name)
   {
      super (name);
   }

   void occupation ()
   {
      System.out.println ("Farmer " + name + " raises beef cattle");
   }
}

class AnonymousInnerClassDemo2
{
   public static void main (final String [] args)
   {
      BeefFarmer bf = new BeefFarmer ("John Doe");
      bf.occupation ();

      new Farmer ("Jane Doe")
          {
              private String count;

              {
                 if (args.length == 1)
                     count = args [0];
              }

              void occupation ()
              {
                 if (count == null)
                     System.out.println ("Farmer " + name + " milks cows");
                 else
                     System.out.println ("Farmer " + name + " milks " +
                                         count + " cows");
              }
          }.occupation ();
   }
}
