// AnonymousInnerClassDemo3.java

import java.awt.*;
import java.awt.event.*;

class AnonymousInnerClassDemo3
{
   public static void main (String [] args)
   {
      // Create a rectangular frame window with a title bar at the top.

      Frame f = new Frame ("Anonymous Inner Class Demo #3");

      // Add a window listener that will generate a window closing event
      // in response to user attempts to click the little X button (on
      // Windows platforms) to the right of the title bar. When the user
      // clicks that button, the window closing event results in a call
      // to a method named windowClosing().  By calling System.exit (0);
      // from within that method, the application exits.

      f.addWindowListener (new WindowAdapter ()
                           {
                               public void windowClosing (WindowEvent e)
                               {
                                  System.exit (0);
                               }
                           });

      // Establish the frame window's size as 300 horizontal pixels by
      // 100 vertical pixels.

      f.setSize (300, 100);

      // Display the frame window and get the underlying event handling
      // system running.

      f.setVisible (true);
   }
}
