// JobIterator2.java

class Job
{
   private String jobTitle;

   Job (String jobTitle)
   {
      this.jobTitle = jobTitle;
   }

   public String toString ()
   {
      return jobTitle;
   }
}

class Employee
{
   private String name;
   private Job [] jobs;

   Employee (String name, Job [] jobs)
   {
      this.name = name;
      this.jobs = jobs;
   }

   String getName ()
   {
      return name;
   }

   JobIterator getJobIterator ()
   {
      return new JobIterator (jobs);
   }
}

class JobIterator
{
   private Job [] jobs;
   private int jobIndex = 0;

   JobIterator (Job [] jobs)
   {
      this.jobs = jobs;
   }

   boolean hasMoreJobs ()
   {
      return jobIndex < jobs.length;
   }

   Job nextJob ()
   {
      return !hasMoreJobs () ? null : jobs [jobIndex++];
   }
}

class JobIterator2
{
   public static void main (String [] args)
   {
      Job [] jobs = { new Job ("Janitor"), new Job ("Delivery Person") };

      Employee e = new Employee ("John Doe", jobs);

      System.out.println (e.getName () + " works the following jobs:\n");

      JobIterator ji = e.getJobIterator ();

      while (ji.hasMoreJobs ())
         System.out.println (ji.nextJob ());
   }
}
         
