// JobIterator3.java

class Job
{
   private String jobTitle;

   Job (String jobTitle)
   {
      this.jobTitle = jobTitle;
   }

   public String toString ()
   {
      return jobTitle;
   }
}

class Employee
{
   private String name;
   private Job [] jobs;

   Employee (String name, Job [] jobs)
   {
      this.name = name;
      this.jobs = jobs;
   }

   String getName ()
   {
      return name;
   }

   JobIterator getJobIterator ()
   {
      return new JobIterator ();
   }

   class JobIterator
   {
      private int jobIndex = 0;

      public boolean hasMoreJobs ()
      {
         return jobIndex < jobs.length;
      }

      public Object nextJob ()
      {
         return !hasMoreJobs () ? null : jobs [jobIndex++];
      }
   }
}

class JobIterator3
{
   public static void main (String [] args)
   {
      Job [] jobs = { new Job ("Janitor"), new Job ("Delivery Person") };

      Employee e = new Employee ("John Doe", jobs);

      System.out.println (e.getName () + " works the following jobs:\n");

      Employee.JobIterator eji = e.getJobIterator ();

      while (eji.hasMoreJobs ())
         System.out.println (eji.nextJob ());
   }
}
         
