// LocalInnerClassDemo.java

import java.util.*;

class ComputerLanguage
{
   private String name;

   ComputerLanguage (String name)
   {
      this.name = name;
   }

   public String toString ()
   {
      return name;
   }
}

class LocalInnerClassDemo
{
   public static void main (String [] args)
   {
      ComputerLanguage [] cl = 
      {
         new ComputerLanguage ("Ada"),
         new ComputerLanguage ("Algol"),
         new ComputerLanguage ("APL"),
         new ComputerLanguage ("Assembly - IBM 360"),
         new ComputerLanguage ("Assembly - Intel"),
         new ComputerLanguage ("Assembly - Mostek"),
         new ComputerLanguage ("Assembly - Motorola"),
         new ComputerLanguage ("Assembly - VAX"),
         new ComputerLanguage ("Assembly - Zilog"),
         new ComputerLanguage ("BASIC"),
         new ComputerLanguage ("C"),
         new ComputerLanguage ("C++"),
         new ComputerLanguage ("Cobol"),
         new ComputerLanguage ("Forth"),
         new ComputerLanguage ("Fortran"),
         new ComputerLanguage ("Java"),
         new ComputerLanguage ("LISP"),
         new ComputerLanguage ("Logo"),
         new ComputerLanguage ("Modula 2"),
         new ComputerLanguage ("Pascal"),
         new ComputerLanguage ("Perl"),
         new ComputerLanguage ("Prolog"),
         new ComputerLanguage ("Snobol")
      };

      Enumeration e = enumerator ((Object []) cl);

      while (e.hasMoreElements ())
         System.out.println (e.nextElement ());
   }

   static Enumeration enumerator (final Object [] array)
   {
      class LocalInnerClass implements Enumeration
      {
         private int index = 0; 

         public boolean hasMoreElements ()
         {
            return index < array.length;
         }

         public Object nextElement ()
         {
            return array [index++].toString ();
         }
      }

      return new LocalInnerClass ();
   }
}
